<?php
// +-----------------------------------------------------------------------+
// | Piwigo - a PHP based picture gallery                                  |
// +-----------------------------------------------------------------------+
// | Copyright(C) 2008-2009 Piwigo Team                  http://piwigo.org |
// | Copyright(C) 2003-2008 PhpWebGallery Team    http://phpwebgallery.net |
// | Copyright(C) 2002-2003 Pierrick LE GALL   http://le-gall.net/pierrick |
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+

/*
Plugin Name: Mail supervisor
Version: 1.2.2
Description:  Mail supervisor surveille l'envoie des mails. 
Plugin URI: http://piwigo.org/ext/extension_view.php?eid=315
Author: cljosse
Author URI:http://cl.josse.free.fr
*/

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

if (!defined('MAIL_SUPERV_DIR')) define('MAIL_SUPERV_DIR' , basename(dirname(__FILE__)));
if (!defined('MAIL_SUPERV_PATH')) define('MAIL_SUPERV_PATH' , PHPWG_PLUGINS_PATH.basename(dirname(__FILE__)).'/');

include_once (MAIL_SUPERV_PATH.'include/constants.php'); 
include_once (MAIL_SUPERV_PATH.'include/fonctions.php'); 

/*
EVENT_HANDLER_PRIORITY_NEUTRAL  */

add_event_handler('send_mail', 'clj_mail',EVENT_HANDLER_PRIORITY_NEUTRAL - 1 , 6);

function clj_mail($result, $mailto, $subject, $content, $headers, $args)
{
    global $conf, $user, $lang_info,  $conf_mail,$mails_options,$mails_donnes , $template,$page ,$erreur_message,$infos_message, $lang; 
	// lecture config table -------------
 load_language('plugin.lang', MAIL_SUPERV_PATH);
   
	$mails_options = explode("," , $conf['mail_superv']);
	$message ="";
	if (!isset($infos_message))
	{
    	$infos_message = "";
	}
if (!isset($erreur_message))
	{
    	$erreur_message = '';
	}
	// lecture donnes       -------------
    $mails_donnes = Get_Datas();

	
	$nb_mails	  =	$mails_donnes['nb_mails'] ;
	$next_day  =  $mails_donnes['date_mail'] ;
	
	$reste =    $mails_donnes['reste'] ;
	
	
	$rest_mail =    $mails_donnes['rest_mail'] ;
	if ($rest_mail <=0 || $mails_donnes['nb_mails'] ==0 ){
	   $mails_donnes['nb_mails'] =0 ;
	   $mails_donnes['date_mail'] = time();
	}
	
	$rest_spam =    $mails_donnes['rest_spam'] ;
 	if ($rest_spam <=0 || $mails_donnes['nb_spams'] ==0 ){
	   $mails_donnes['nb_spams'] =0 ;
	   $mails_donnes['date_spam'] = time();
	}
	
	$alerte =   ( $mails_donnes['reste'] >0 ) ? true : false ; 
	
	$alerte_mail =    ( $mails_donnes['nb_mails'] >   $mails_donnes['nb_mails_maxi']-1 ) ? true : false ;
	$alerte_spam =    (  $mails_donnes['nb_spams'] >   $mails_donnes['nb_spams_maxi']-1 ) ? true : false ;
	
 
 if ( ( !$alerte  && !$alerte_spam  && !$alerte_mail ) ) 
  	{
	     	 
  $nb_destinataires=0;
		if ($mails_options[0] == 'on') {
 			if ($mailto == "" )	$mailto = $conf_mail['email_webmaster'];
		}    
 if ($mailto<>"" )            $nb_destinataires +=1; 

 		if (!empty($args['Bcc']))  {  
 			$nb_destinataires += count($args['Bcc']); 
			} 
		if (!empty($args['Cc']))  {   
 			$nb_destinataires += count($args['Cc']); 
			}
   //================= rcriture de l'entte ===============================
if ( $nb_destinataires  == 1 )
	{
		if ($mailto == "" ) 
		  {
		  	  if (!empty($args['Cc']) and count($args['Cc']) > 0 )  $mailto  = get_strict_email_list(implode(',', $args['Cc'])) ;
	 	 	  if (!empty($args['Bcc']) and count($args['Bcc']) > 0 ) $mailto  = get_strict_email_list(implode(',', $args['Bcc'])) ;
			 
				$headers = preg_replace('/.*Bcc(.*).\n/i', '', $headers);
				$headers = preg_replace('/.*Cc(.*).\n/i', '', $headers);
				
		  }
	}else{
   
  
     }

//=============================================================================		
if (!empty($args['Cc']))
  			{
    			 $headers= corrige_header('Cc',$headers,$args);
  			}
  		if (!empty($args['Bcc']))
  			{   
		   		   $headers	= corrige_header('Bcc',$headers,$args); 
			}
//=============================================================================			
if ($mails_options[2]=='on')   {

        $texte = "This is a multi-part message in MIME format.\n"; 
	
     	$texte .= "-----=".$conf_mail['boundary_key']."\n"; 
      	$texte .= "Ceci est un message est au format MIME.\n"; 
       	$texte .= 'Content-Type: text/plain; charset="UTF-8"'."\n"; 
       	$texte .= 'Content-Transfer-Encoding: 8bit'."\n\n";  
       	$texte .= $mails_donnes['header_text']; // A voir texte brut...
	   
	   	$texte .= "\n\n"; 
	
	  	$content =$texte .$content ;
}
 
$ret=false;
	
 	    //======== Non mise en quarantaine =============
   		ob_start();
		$ret = false;
		 if ($nb_destinataires > 0) {
   	           $ret = mail($mailto, $subject, $content, $headers);

			}else{
			   $message .='Nombre de destinataires = 0';
			}
 	  		$message .= ob_get_contents();
    	    ob_end_clean();
			$mails_donnes['message']=$message;	
	 		Gestion_erreurs($message,$ret,$nb_destinataires,$headers,$mailto);
		
  	
	
	} else {

	//================== Est en quarantaine =======================	
		$erreur_message .= 	l10n('To_day_is')."<br />";
			if ($alerte_spam ) { 
		        $type="Spams";
				
				$d1=$mails_donnes['nb_spams'] . '  \\  ' . $mails_donnes['nb_spams_maxi'];
				$d2=$mails_donnes['nb_spams'];
 				$d3= $mails_donnes['rest_spam'];
				$d4=time()+$d3 ;
 			} 
 
			if ($alerte_mail) {
		        $type="Mails";
		        
				$d1=$mails_donnes['nb_mails']. '  \\  ' . $mails_donnes['nb_mails_maxi'];;
				$d2=$mails_donnes['date_mail'];
 				$d3= $mails_donnes['rest_mail'];
				$d4=time()+$d3 ;
				
				
 			}
			if ($alerte) {
		        $type="Spams(Quarantaine)";
				$d1=$mails_donnes['nb_spams'] . '  \\  ' . $mails_donnes['nb_spams_maxi'];
				$d2=$mails_donnes['date_quarantaine'];
 				$d3= $mails_donnes['reste'];
				$d4=time()+$d3 ;
 			} 


$d2=date(l10n('formatdate'),$d2);
$d3=int_to_heure($d3) ;
$d4=date(l10n('formatdate'),$d4);

	if ($alerte_mail) {
	      $erreur_message .='<br />'.sprintf(l10n('alerte_mail %s %s %s %s %s'),$type,$d1,$d2,$d3,$d4).'<br />';
 		}else{
		 	   $erreur_message .='<br />'.sprintf(l10n('mise_en_quarantaine %s %s %s %s %s'),$type,$d1,$d2,$d3,$d4).'<br />';

		}
 $infos_message = l10n('mail_not_send');
 
 }			
 sauve_donnes();
 return true ;
}
//===========================================================================================	
function Gestion_erreurs($message,$ret,$nb_destinataires,$headers,$mailto)
{			
	 global $conf, $user, $lang_info,  $conf_mail,$mails_options,$mails_donnes , $template,$page ,$infos_message,$erreur_message,$args; 
    $match=array("<",">");
    $string=array("&lt;","&gt;") ;	 

//Warning: mail() has been disabled for security reasons 
	
	$est_un_spam =!(strpos(strtolower($message), 'spam') === false);
	$headers=str_replace( $match,$string, $headers); 
	
	if ( ($ret==false) || ($est_un_spam==true) || ($nb_destinataires == 0) ) {
		 ;				// Bad recipient address syntax 
 		$pos1 = strpos(strtolower($message), 'bad recipient address syntax');
		if (  !($pos1 === false) ){
			$erreur_message .=l10n('Dtection_de').' : Bad recipient address syntax .';
 			$erreur_message .=l10n('Vrifiez_les_destinataires').' (Bcc,Cc,To)<br />';
 			}	
	
	$erreur_message .= sprintf(l10n('debug_message %s %s %s %s %s'),($ret==true)? "true" : "false",$message,$mailto,$headers,$nb_destinataires);
       //=============== La fonction mail  retourneune erreur =========================		

				
				}	
				
    	if ($est_un_spam == false) 
			{
    			if ($mails_donnes['nb_mails']==0) {	$mails_donnes['date_mail'] =  time();	} 	
 	    		$mails_donnes['nb_mails'] += $nb_destinataires;
			}
			else
			{
				$mails_donnes['nb_spams'] += $nb_destinataires;			
			    //--- Dtection de spam ------------------
				if ($mails_donnes['nb_spams']==0) {$mails_donnes['date_spam'] = time(); 	}

				$trop_de_spam =!(strpos(strtolower($message), 'trop de spam') === false);
				if ( $trop_de_spam ) {
						$mails_donnes['nb_spams_maxi']=$mails_donnes['nb_spams'];

						$mails_donnes['date_quarantaine']= time()  ;	
						$mails_donnes['quarantaine']= true    ;	
						$infos_message .=memo_var($mails_donnes);
					}

 			}
 
 

 
 $ret=true;
 return $ret ;
 
}

//==========================================================================================
function admin_menu($menu)
{
    array_push($menu, array('NAME' => 'Mail_Superv',
      'URL' => get_admin_plugin_menu_link(MAIL_SUPERV_PATH . 'admin/mail_superv_admin.php')));
    return $menu;
}


add_event_handler('get_admin_plugin_menu_links', 'admin_menu');
//add_event_handler('loc_end_page_tail', 'affiche_message');
add_event_handler('loc_after_page_header', 'affiche_message');
?>
